//////////////////////////////
// gdx_deat.c
// written by Michael Gibson
// released under the GPl
// (c) 2004-2017
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

 char indi_check[6];
 char indi_num[6];
 char filename[55];

 //9999 charcters by 9999 lines
 //this clears up memory problems with really large GEDCOM files
 char data_line[9999][9999];
 int number_of_lines=0;

// char indi_refn[95];     //REFN =reference(user-defined key)
// int  indi_refn_t;

 char indi_name[95];       //NAME = first middle last(surname) name
 char indi_name_tmp[95];
 int  indi_name_t=0;
 int  indi_name_m=0;
 int  flex_name;

 char indi_sex[7];
 int  indi_sex_t=0;

 char indi_deat_date[90];
 char indi_deat_date_tmp[90];
 int  indi_deat_date_t=0;
 int  indi_deat_date_m=0;
 int  flex_deat_date;

 char indi_deat_plac[90];
 char indi_deat_plac_tmp[90];
 int  indi_deat_plac_t;
 int  indi_deat_plac_m;
 int  flex_deat_plac;

 char indi_deat_note[95];
 char indi_deat_note_tmp[95];
 int  indi_deat_note_t;
 int  indi_deat_note_m;
 int  flex_deat_note;

 char indi_buri_date[90];
 char indi_buri_date_tmp[90];
 int  indi_buri_date_t;
 int  indi_buri_date_m;
 int  flex_buri_date;

 char indi_buri_plac[90];
 char indi_buri_plac_tmp[90];
 int  indi_buri_plac_t;
 int  indi_buri_plac_m;
 int  flex_buri_plac;

 char indi_buri_note[95];     // final value
 char indi_buri_note_tmp[95]; // stored value
 int  indi_buri_note_t;       // text box widget for value
 int  indi_buri_note_m;       // toggle value
 int  flex_buri_note;         // toggle button widget 

 char indi_crem_date[90];
 char indi_crem_date_tmp[90];
 int  indi_crem_date_t;
 int  indi_crem_date_m;
 int  flex_crem_date;

 char indi_crem_plac[90];
 char indi_crem_plac_tmp[90];
 int  indi_crem_plac_t;
 int  indi_crem_plac_m;
 int  flex_crem_plac;

 char indi_crem_note[95];     // final value
 char indi_crem_note_tmp[95]; // stored value
 int  indi_crem_note_t;       // text box widget for value
 int  indi_crem_note_m;       // toggle value
 int  flex_crem_note;         // toggle button widget


#include "markdata2.c"


/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
void destroy(void)
{

    char systemstring[50];
    sprintf(systemstring, "./gedlist %s &",filename);
    system("killall gedlist");
    system(systemstring);
    gdx_closewindow();
}


////////////////////////////////////////////////////
//// family
///////////////////////////////////////////////////
void family(void)
{

  char systemstring[164];

  sprintf(systemstring,"./gedchild %s %s 1 &",indi_num,filename);
  system(systemstring);
}
////////////////////////////////////////////////////
//
///////////////////////////////////////////////////
void parent(void)
{

  char systemtext[60];

  sprintf(systemtext,"./gedtree %s %s &",filename, indi_num);

  system(systemtext);

}

void help(void)
{
 
  x_imgbox("images/helptext.xpm","Help");

}


//////////////////////////////
// save
// save individual data
/////////////////////////////
void save(void)
{
  FILE *fp;
  int data_written=0;       //any data written

  int name_written=0;
  int name_needs_written=0;
  int deat_written=0;
  int deat_needs_written=0;
  int buri_written=0;
  int buri_needs_written=0;
  int crem_written=0;
  int crem_needs_written=0;

  char temp[200];
  int x=0;
  int y=0; // loop var
  char indi[10];
  int indi_r=0;
  int write_indi=0;

  //collect data from text entry widgets
  strcpy(indi_name_tmp, gdx_textentry_obj.string[indi_name_t]);
  
  strcpy(indi_deat_plac_tmp, gdx_textentry_obj.string[indi_deat_plac_t]);
  strcpy(indi_deat_date_tmp, gdx_textentry_obj.string[indi_deat_date_t]);
  strcpy(indi_deat_note_tmp, gdx_textentry_obj.string[indi_deat_note_t]);

  strcpy(indi_buri_plac_tmp, gdx_textentry_obj.string[indi_buri_plac_t]);
  strcpy(indi_buri_date_tmp, gdx_textentry_obj.string[indi_buri_date_t]);
  strcpy(indi_buri_note_tmp, gdx_textentry_obj.string[indi_buri_note_t]);

  //if the field contains data and the data has changed
  if(strlen(indi_name_tmp) >= 2 && strcmp(indi_name,indi_name_tmp)!=0) name_needs_written=1;


  if(strlen(indi_deat_date_tmp) >= 2  && strcmp(indi_deat_date,indi_deat_date_tmp)!=0 ) deat_needs_written=1;
  if(strlen(indi_deat_plac_tmp) >= 2  && strcmp(indi_deat_plac,indi_deat_plac_tmp)!=0 ) deat_needs_written=1;
  if(strlen(indi_deat_note_tmp) >= 2  && strcmp(indi_deat_note,indi_deat_note_tmp)!=0 ) deat_needs_written=1;
  if(deat_needs_written==1 && strlen(indi_deat_date_tmp)<=1) strcpy (indi_deat_date_tmp,"n/a");
  if(deat_needs_written==1 && strlen(indi_deat_plac_tmp)<=1) strcpy (indi_deat_plac_tmp,"n/a");
  if(deat_needs_written==1 && strlen(indi_deat_note_tmp)<=1) strcpy (indi_deat_note_tmp,"n/a");

  if(strlen(indi_buri_date_tmp) >= 2  && strcmp(indi_buri_date,indi_buri_date_tmp)!=0 ) buri_needs_written=1;
  if(strlen(indi_buri_plac_tmp) >= 2  && strcmp(indi_buri_plac,indi_buri_plac_tmp)!=0 ) buri_needs_written=1;
  if(strlen(indi_buri_note_tmp) >= 2  && strcmp(indi_buri_note,indi_buri_note_tmp)!=0 ) buri_needs_written=1;
  if(buri_needs_written==1 && strlen(indi_buri_date_tmp)<=1) strcpy (indi_buri_date_tmp,"n/a");
  if(buri_needs_written==1 && strlen(indi_buri_plac_tmp)<=1) strcpy (indi_buri_plac_tmp,"n/a");
  if(buri_needs_written==1 && strlen(indi_buri_note_tmp)<=1) strcpy (indi_buri_note_tmp,"n/a");

/// now for updated data ///

  if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }

  //write data
  for(x=0;x<=number_of_lines;x++){
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == atoi(indi_num)) {
        write_indi=1;
        printf("lets write....\n");
      }
      if(indi_r != atoi(indi_num)) write_indi=0;
    }
    //1 NAME
    if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A' && temp[4]=='M' && write_indi==1){
        sprintf(data_line[x],"1 NAME %s\n",indi_name_tmp);
        data_written=1;
        name_written=1;
        strcpy(indi_name,indi_name_tmp);
    }
    
    // 1 DEAT
    if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4]=='A' && write_indi==1){
       sprintf(data_line[x],"1 DEAT \n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",indi_deat_date_tmp,indi_deat_plac_tmp,indi_deat_note_tmp);
       data_written=1;
       deat_written=1;
       strcpy(indi_deat_date,indi_deat_date_tmp);
       strcpy(indi_deat_plac,indi_deat_plac_tmp);
       strcpy(indi_deat_note,indi_deat_note_tmp);
     }

   // 1 BURI
    if(temp[0]=='1' && temp[2]=='B' && temp[3]=='U' && temp[4]=='R' && write_indi==1){
       sprintf(data_line[x],"1 BURI \n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",indi_buri_date_tmp,indi_buri_plac_tmp,indi_buri_note_tmp);
       data_written=1;
       buri_written=1;
       strcpy(indi_buri_date,indi_buri_date_tmp);
       strcpy(indi_buri_plac,indi_buri_plac_tmp);
       strcpy(indi_buri_note,indi_buri_note_tmp);
    }

    //write_data
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);

/// Now for new data ////

 if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }

  //write data


  for(x=0;x<=number_of_lines;x++){
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == atoi(indi_num)) {
        write_indi=1;
        printf("lets write....\n");
      }
      if(indi_r != atoi(indi_num)) write_indi=0;
    }



    //1 DEAT after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&deat_written==0&&deat_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 DEAT\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_deat_date_tmp,indi_deat_plac_tmp,indi_deat_note_tmp);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //1 BURI after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&buri_written==0&&buri_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 BURI\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_buri_date_tmp,indi_buri_plac_tmp,indi_buri_note_tmp);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //write_data
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);

  if(data_written==1) x_msgbox(5,"Data has been saved","Saved","fixed",50);

}


//////////////////////////////////
// add spouce
////////////////////////////////////////
void add_spouce(void)
{
  char spouce_string[90];
  if(indi_sex[0]=='F')
    sprintf(spouce_string,"./gedadd_spouce %s %s M",indi_num,filename);
  if(indi_sex[0]=='M')
    sprintf(spouce_string,"./gedadd_spouce %s %s F",indi_num,filename);
  system(spouce_string);

}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  char last_action[15];


  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03, button_04, button_05;
  int button_06, button_07, button_08;
  int label0,label1,label2;
  
  int label3; //sex 
 
  int label4,label5,label6;
  int label7,label8;

  int label9; //death date

  int label10,label11, label12, label13;
  int label14, label15, label16, label17, label18, label19;
  int label21;
  int readflag=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[1]);
  strcpy(indi_num, argv[2]);
  strcpy(indi_name,"\0");

  strcpy(indi_deat_plac,"\0");
  strcpy(indi_deat_date,"\0");
  strcpy(indi_deat_note,"\0");

  strcpy(indi_buri_plac,"\0");
  strcpy(indi_buri_date,"\0");
  strcpy(indi_buri_note,"\0");

  strcpy(indi_crem_date,"\0");
  strcpy(indi_crem_plac,"\0");
  strcpy(indi_crem_note,"\0");


  mark_indi();

  fp5=fopen(argv[1],"r+");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Individual",790,520);
  gdx_setwindowbg("images/bg.xpm",1);


  gdx_frame(50,18,780,475,"Individual data for GEDCOM ID:");

  button_01 = gdx_imagebutton(5,18,"images/close.xpm",destroy);
  button_06 = gdx_imagebutton(5,48,"images/filesave.xpm",save);
  button_08 = gdx_imagebutton(45,485,"images/submit.xpm",save);
  button_02 = gdx_imagebutton(5,78,"images/pari.xpm",parent);
  button_03 = gdx_imagebutton(5,108,"images/chil.xpm",family);
  button_04 = gdx_imagebutton(5,138,"images/marr.xpm",add_spouce);
  button_05 = gdx_imagebutton(5,168,"images/help.xpm",help);

  label0 = gdx_label(argv[2],232,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  //main start of read

  do{
    //check for level 0
    fgets(input1,80,fp5);

    //store all data for later use
    strcpy(data_line[loopy],input1);
    loopy++;

     //01234567890123
     //0 @I0001@ INDI
     if(input1[0]=='0'&& input1[2]=='@' && input1[3]=='I' && input1[10]=='I' && input1[11]=='N'){

        //Great!, the level 0 is an individual

        for(x=5;x<80;x++) if(input1[x]=='@' ||input1[x]=='I') input1[x]=' ';
        sprintf(indi_check,"%c%c%c%c",input1[4],input1[5],input1[6],input1[7]);

        //check to see if it is the idividual we are looking for 
        if(atoi(indi_check)==atoi(argv[2])){
          //hot grits! it is the idividual we were looking for
          readflag=1;
        }
        else readflag=0;
     }// end if indi found

      if(input1[0]=='1' && input1[2]=='N' && input1[3]=='A' && readflag==1){     ///1 NAME
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_name,input1);
      }


      if(input1[0]=='1' && input1[2]=='S' && input1[3]=='E' &&readflag==1){   ///1 SEX
        indi_sex[0]=input1[6];
        indi_sex[1]='\0';
      }



// last actions


      if(input1[0]=='1' && input1[2]=='B' && input1[3]=='U' && input1[4] =='R'&&readflag==1){ //1 BURI
        strcpy(last_action,"BURI");
      }
      if(input1[0]=='1' && input1[2]=='C' && input1[3]=='R' && input1[4] =='E'&&readflag==1){ //1 CREM
        strcpy(last_action,"CREM");
      }
      if(input1[0]=='1' && input1[2]=='D' && input1[3]=='E' && input1[4] =='A'&&readflag==1){ //1 DEAT
        strcpy(last_action,"DEAT");
      }


  if(input1[0]=='1' && input1[2]=='B' && input1[3]=='I'){ //1 BIRT
    strcpy(last_action,"BIRT");
  }
  if(input1[0]=='1' && input1[2]=='N' && input1[3]=='A'){ //1 NAME
    strcpy(last_action,"NAME");
  }
  if(input1[0]=='1' && input1[2]=='C' && input1[3]=='H'){ //1 CHAN
    strcpy(last_action,"CHAN");
  }
  if(input1[0]=='1' && input1[2]=='E' && input1[3]=='V'){ //1 EVEN
    strcpy(last_action,"EVEN");
  }
  if(input1[0]=='1' && input1[2]=='F' && input1[3]=='A'){ //1 FAMC
    strcpy(last_action,"FAMC");
  }
  if(input1[0]=='1' && input1[2]=='F' && input1[3]=='A'){ //1 FAMS
    strcpy(last_action,"FAMS");
  }



// date-> Burial Date, Cremation date, and Death Date

       if(input1[0]=='2' && input1[2]=='D' && input1[3]=='A'&&readflag==1){ //2 DATE
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='B' && last_action[1]=='U'&&readflag==1){
            strcpy(indi_buri_date,input1);
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_date,input1);
          }
       }

// Brith Place, Death Place, Burial Place
 
       if(input1[0]=='2' && input1[2]=='P' && input1[3]=='L'&&readflag==1){ //2 PLAC
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_plac,input1);
          }
          if(last_action[0]=='B' && last_action[1]=='U'&&readflag==1){
            strcpy(indi_buri_plac,input1);
          }
       }


// Brith Note, Burial Note, and Death Note

       if(input1[0]=='2' && input1[2]=='N' && input1[3]=='O'&&readflag==1){ //2 Note 
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='B' && last_action[1]=='U'&&readflag==1){
            strcpy(indi_buri_note,input1);
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_note,input1);
          }
       }





  }while(input1[0] !='0' || input1[2] !='T');

  number_of_lines=loopy;

  //display
  //Name
  label1 = gdx_label("Name:",55,35,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name_t=gdx_textentry(140,25,250,0);
  gdx_settextentry(indi_name_t,indi_name);
  if(indi_name_m==0)flex_name=gdx_imagebutton(400,23,"images/update.xpm",mark_name);
  if(indi_name_m==1)flex_name=gdx_imagebutton(400,23,"images/update2.xpm",mark_name);


  //Sex
  label3=gdx_label("Sex:",55,65,0);
  gdx_setlabelbg("images/bg.xpm",1,label3);
  indi_sex_t=gdx_textentry(140,55,20,0);
  gdx_settextentry(indi_sex_t,indi_sex);





  //Death Date
  label9=gdx_label("Death Date:",55,155,0);
  gdx_setlabelbg("images/bg.xpm",1,label9);
  indi_deat_date_t=gdx_textentry(140,145,100,0);
  gdx_settextentry(indi_deat_date_t,indi_deat_date);
  if(indi_deat_date[0]=='\0'){
    gdx_image(250,142,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_deat_date_m==0)flex_deat_date=gdx_imagebutton(250,142,"images/update.xpm",mark_deat_date);
    if(indi_deat_date_m==1)flex_deat_date=gdx_imagebutton(250,142,"images/update2.xpm",mark_deat_date);
  }

  //Death Place
  label10=gdx_label("Death Place:",295,155,0);
  gdx_setlabelbg("images/bg.xpm",1,label10);
  indi_deat_plac_t=gdx_textentry(380,145,350,0);
  gdx_settextentry(indi_deat_plac_t,indi_deat_plac);
  if(indi_deat_plac[0]=='\0'){
    gdx_image(740,142,"images/tree_info.xpm");
  }

  label11 = gdx_label("Death Note:",55,180,0);
  gdx_setlabelbg("images/bg.xpm",1,label11);
  indi_deat_note_t=gdx_textentry(140,170,350,0);
  gdx_settextentry(indi_deat_note_t,indi_deat_note);
  if(indi_deat_note[0]=='\0'){
    gdx_image(500,168,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_deat_note_m==0)flex_deat_note=gdx_imagebutton(500,168,"images/update.xpm",mark_deat_note);
    if(indi_deat_note_m==1)flex_deat_note=gdx_imagebutton(500,168,"images/update2.xpm",mark_deat_note);
  }

  label16 = gdx_label("Burial date:",55,225,0);
  gdx_setlabelbg("images/bg.xpm",1,label16);
  indi_buri_date_t=gdx_textentry(140,215,100,0);
  gdx_settextentry(indi_buri_date_t,indi_buri_date);
  if(indi_buri_date[0]=='\0'){
    gdx_image(250,212,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_buri_date_m==0)flex_buri_date=gdx_imagebutton(250,212,"images/update.xpm",mark_buri_date);
    if(indi_buri_date_m==1)flex_buri_date=gdx_imagebutton(250,212,"images/update2.xpm",mark_buri_date);
  }

  label17 = gdx_label("Burial Place:",295,225,0);
  gdx_setlabelbg("images/bg.xpm",1,label17);
  indi_buri_plac_t=gdx_textentry(380,215,350,0);
  gdx_settextentry(indi_buri_plac_t,indi_buri_plac);
  if(indi_buri_plac[0]=='\0'){
    gdx_image(740,212,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_buri_plac_m==0)flex_buri_plac=gdx_imagebutton(740,212,"images/update.xpm",mark_buri_plac);
    if(indi_buri_plac_m==1)flex_buri_plac=gdx_imagebutton(740,212,"images/update2.xpm",mark_buri_plac);
  }


  label18 = gdx_label("Burial Note:",55,250,0);
  gdx_setlabelbg("images/bg.xpm",1,label18);
  indi_buri_note_t=gdx_textentry(140,240,350,0);
  gdx_settextentry(indi_buri_note_t,indi_buri_note);
  if(indi_buri_note[0]=='\0'){
    gdx_image(500,238,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_buri_note_m==0)flex_buri_note=gdx_imagebutton(500,238,"images/update.xpm",mark_buri_note);
    if(indi_buri_note_m==1)flex_buri_note=gdx_imagebutton(500,238,"images/update2.xpm",mark_buri_note);
  }



  gdx_main();
  x_close();

  return(0);
}

